import uno
import os
import pandas as pd
import numpy as np
import subprocess
import locale
import colorsys

locale.setlocale(locale.LC_ALL, '')
LongueurMaxString = 20

# font ;: récupérer tableau


def ChargeZone(Zone):

    MaData = pd.DataFrame(Zone.getDataArray())

    MaData.columns = MaData.iloc[0]
    MaData = MaData[1:]

    return MaData


def TraiteZoneType(Zone, TypeZone):

    # TypeZone A : \fonction [col1] [x=…,y=…]   en itérant sur les colonnes
    # TypeZone B : \fonction [col0] [col1]
    # TypeZone C : \fonction        [x=…,y=…]   en itérant sur les lignes pour x,y,… (mais aussi les colonnes mais que une...)
    # TypeZone D : \fonction [colk] [x=…,y=…] … en itérant sur les lignes pour x,y,… ET sur les colonnes pour colk
    # TypeZone E : \fonctionk                   en itérant sur les lignes pour fonctionk

    MaData = ChargeZone(Zone)
    NomColonnes = MaData.columns.values.tolist()

    TexteSortie = "\n"

    # ------------------------------------------------------------------

    if TypeZone == 'A' or TypeZone == 'B' or TypeZone == 'E':

        MaData[NomColonnes[1]] = MaData[NomColonnes[1]].replace('', np.nan)
        MaData = MaData.dropna(subset=[NomColonnes[1]])

        for index, row in MaData.iterrows():

            if TypeZone == 'A' or TypeZone == 'B':
                TexteSortie = TexteSortie + str(NomColonnes[0])

    # ------------------------------------------------------------------
            if TypeZone == 'A':

                TexteSortie = \
                    TexteSortie + " [" + \
                    (str(row[NomColonnes[1]]) + "]") \
                    .ljust(LongueurMaxString) + "["

                for j in range(len(row)-2):
                    NomColonne = NomColonnes[j+2]
                    TexteSortie = TexteSortie + \
                        str(NomColonne) + "=" + str(row[NomColonne])

                    if j < len(row)-3:
                        TexteSortie = TexteSortie + ","
                    else:
                        TexteSortie = TexteSortie + "]"

    # ------------------------------------------------------------------
            if TypeZone == 'B':

                TexteSortie = TexteSortie + " [" + \
                    (str(row[NomColonnes[0]]) + "]")\
                    .ljust(LongueurMaxString) + \
                    "[" + str(row[NomColonnes[1]]) + "]"

    # ------------------------------------------------------------------
            if TypeZone == 'E':

                if row[NomColonnes[1]] == "yes":

                    TexteSortie = TexteSortie + str(row[NomColonnes[0]])

    # ------------------------------------------------------------------

            TexteSortie = TexteSortie + "\n"

# ------------------------------------------------------------------

    if TypeZone == 'C' or TypeZone == 'D':

        for i in range(MaData.shape[1]-1):

            TexteSortie = TexteSortie + \
                str(NomColonnes[0]) + "\n"

            if TypeZone == 'D':
                TexteSortie = TexteSortie + \
                    "  [" + str(NomColonnes[i+1]) + "]\n"

            TexteSortie = TexteSortie + "  [\n"

            for j in range(MaData.shape[0]):

                if str(MaData.iloc[j, i+1]) != "":
                    TexteSortie = TexteSortie + \
                        "   " + str(MaData.iloc[j, 0]) + "=" +\
                        str(MaData.iloc[j, i+1]) + ",\n"

            TexteSortie = TexteSortie + "  ]\n\n"

    TexteSortie = TexteSortie + "\n"

    return TexteSortie


def rgb2int(r, g, b):
    return (256**2) * int(r, 16) + 256*int(g, 16) + int(b, 16)


def Colorier(MaSheet, NomTable):

    # pas robuste car getCellByPosition en dur,
    # indépendantes de la position du range

    MaZone = MaSheet.getCellRangeByName(NomTable)
    NombreCouleur = MaZone.Rows.Count - 1
    StartCouleur = MaZone.RangeAddress.StartRow + 1

    for iCouleur in range(NombreCouleur):

        if MaSheet.getCellByPosition(2, StartCouleur+iCouleur).String != "":

            MaSheet.getCellByPosition(1, StartCouleur+iCouleur).String = \
                str(MaSheet.getCellByPosition(3, StartCouleur+iCouleur).Value)

            rgb = colorsys.hsv_to_rgb(
                MaSheet.getCellByPosition(3, StartCouleur+iCouleur).Value/360.,
                MaSheet.getCellByPosition(4, StartCouleur+iCouleur).Value,
                MaSheet.getCellByPosition(5, StartCouleur+iCouleur).Value)

            rgb = (hex(round(rgb[0]*255)),
                   hex(round(rgb[1]*255)),
                   hex(round(rgb[2]*255)))
            monentier = rgb2int(rgb[0], rgb[1], rgb[2])
            MaSheet.getCellByPosition(1, StartCouleur+iCouleur).String = ""
            MaSheet.getCellByPosition(1,
                StartCouleur+iCouleur).CellBackColor = monentier

        else:
            MaSheet.getCellByPosition(1,
                StartCouleur+iCouleur).String = ""
            MaSheet.getCellByPosition(1,
                StartCouleur+iCouleur).CellBackColor = 14606562


def TraiterOnglet(oDoc, NomOnglet, ListeATraiter, MonPath, FichierSortie):

    MaSheet = oDoc.getSheets().getByName(NomOnglet)

    TexteSortie = ""

    for NamedRange, RangeType in ListeATraiter:

        TexteSortie = TexteSortie + \
            TraiteZoneType(MaSheet.getCellRangeByName(NamedRange), RangeType)

    with open(MonPath + '/' + FichierSortie, 'w') as f:
        f.write(TexteSortie + '\n')
    f.close()


def WriteAndContext(args=None):

    oDoc = XSCRIPTCONTEXT.getDocument()
    MonPath = os.path.dirname(oDoc.getURL().replace('file://', ''))
    os.chdir(MonPath)

    contextPath = "/home/parents/Documents/11-informatique/" +\
                  "11.30-app_context-linux-64/tex/texmf-linux-64/bin/"

    FichierTex = 'readme.tex'

# ------------------------------------------------------------------

    ListeCouleurs = [["TableCouleurs", 'A'],
                     ["TableCouleursGeneriques", 'B'],
                     ["TableSetupCouleurs", 'C']]

    TraiterOnglet(oDoc, "Colors", ListeCouleurs,
                  MonPath, 'env_A05_color.tex')

    Colorier(oDoc.getSheets().getByName("Colors"), "TableCouleurs")

#    process = subprocess.Popen([])

    processA = subprocess.Popen(contextPath +
                                "mtxrun --script font --list --all > " +
                                MonPath + "/liste_fonts.csv",
                                stdout=subprocess.PIPE,
                                shell=True, encoding='utf8')
    try:
        print('Running in process', processA.pid)
        processA.wait(timeout=100)
    except processA.TimeoutExpired:
        print('Timed out - killing', processA.pid)
        processA.kill()
    print("Done")

    dffonts = pd.read_fwf(MonPath + "/liste_fonts.csv").sort_values(by=['familyname', 'fontname'])

    dffontsfamilies = dffonts[["familyname"]].drop_duplicates()

    for i in ["B3", "B4", "B5", "B6"]:

        tempo = dffontsfamilies[dffontsfamilies["familyname"]\
            .str.contains(oDoc.getSheets().getByName("Fonts").getCellRangeByName(i).String.lower().replace(" ", ""))]
        maliste = ";".join(tempo["familyname"].tolist())

        dv_list = oDoc.getSheets().getByName("Fonts").getCellRangeByName(i)
        oValidation = dv_list.Validation
        oValidation.Type = "LIST"
        oValidation.setFormula1(maliste)
        dv_list.Validation = oValidation




    dffonts = dffonts[["fontname"]].drop_duplicates()
    dffonts = dffonts[dffonts["fontname"].str.contains("caslon")]

    maliste = ";".join(dffonts["fontname"].tolist())


    dv_list = oDoc.getSheets().getByName("Fonts").getCellRangeByName("B8")
    oValidation = dv_list.Validation
    oValidation.Type = "LIST"
    oValidation.setFormula1(maliste)
    dv_list.Validation = oValidation
# ------------------------------------------------------------------

    ListeSections = [["TableSections", 'D']]

    TraiterOnglet(oDoc, "Sections", ListeSections,
                  MonPath, 'env_B14_section.tex')

# ------------------------------------------------------------------

    ListeLayout = [["TableLayout", 'C'],
                   ["TableOptions", 'E']]

    TraiterOnglet(oDoc, "Layout", ListeLayout,
                  MonPath, 'env_A01_layout.tex')

# ------------------------------------------------------------------

    processB = subprocess.Popen([contextPath+"context", '--batchmode', FichierTex])
    try:
        print('Running in process', processB.pid)
        processB.wait(timeout=10)
    except processB.TimeoutExpired:
        print('Timed out - killing', processB.pid)
        processB.kill()
    print("Done")

    return None
